@Echo off

setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

rem set some defaults --------------------------------------------------------

 set cfgfile=%~dpn0.cfg
 set pollnodes=%~dpn0.poll
 set eventfile=%~dpn0.event
 set exitflag=%~n0.exit
 set lockfile=%~n0.lock
 set logfile=%~n0.log
 set doneflag=%~n0.done
rem set curdir=%~dp0
 for %%i in (%~dpn0.*) do set filestamp%%~xi=%%~tzi
rem --------------------------------------------------------------------------

Call :ReadCFG

if exist %flagsdir%\%exitflag% del /f/q %flagsdir%\%exitflag%

if exist %flagsdir%\%lockfile% (
   color 4E
   echo !DATE! !TIME:~0,-3! * Lock File found. Exit.
   Call :DoLog " "
   Call :DoLog "Lock File found. Exit."
   Call :DoLog " "
   timeout /NOBREAK /t 2 > nul
   exit 1
) else (
   echo.>%flagsdir%\%lockfile%
)

   Call :DoLog " "
   Call :DoLog " "
   Call :DoLog "Start Up. ----------------------------------------"
   Call :DoLog "~~~~~~~~~ "

Call :ReadPollNodes
Call :ReadEvent

rem timeout /T %TT% >nul
   color 0a

:StartCircle

cls&echo %DATE:.=/% %TIME:~0,-3%
echo ~~~~~~~~~~~~~~~~~~~

rem --- ஢塞,    ஢   㧫 ----------------------

 for /l %%i in (1,1,!node2poll!) do set strnode=__________________!node2poll.%%i.zone!:!node2poll.%%i.net!/!node2poll.%%i.node!.!node2poll.%%i.point!&set strsec=.........!polltriger%%i!&if !polltriger%%i! LEQ 0 (set /a polltriger%%i=!node2poll.%%i.period!&Call :DoLog "Creating Poll to !node2poll.%%i.zone!:!node2poll.%%i.net!/!node2poll.%%i.node!.!node2poll.%%i.point!"&Call :DoPoll !node2poll.%%i.zone! !node2poll.%%i.net! !node2poll.%%i.node! !node2poll.%%i.point!) else (if !polltriger%%i! LEQ !ShowIfTriggerLess! (echo To poll node !strnode:~-19! left !strsec:~-9! sec.))

rem ----஢塞 ᮡ ----------------------------------------------------
rem echo --------------------------------------------------
 for /l %%i in (1,1,!period.0!) do if !period.%%i.trigger! LEQ 0 (
   echo !period.%%i.desc!: !period.%%i.cmd!
   Call :dolog "!period.%%i.desc!: !period.%%i.cmd!"
   cmd /c !period.%%i.cmd!
   Call :dolog "!period.%%i.desc!: End."
   set /a period.%%i.trigger=!period.%%i!
 ) else (
         if !period.%%i.trigger! LEQ !ShowIfTriggerLess! ( 
           set p_e_string=To event "!period.%%i.desc!"...............................
           set p_e_t_string=........!period.%%i.trigger!
           set p_e_string=!p_e_string:~0,32! left !p_e_t_string:~-9! sec.
           echo !p_e_string! 
         )
         set /a period.%%i.trigger=!period.%%i.trigger!-!TT!
        )
rem echo --------------------------------------------------
rem Call :TestHld
rem echo %DATE:.=/% %TIME:~0,-3%
rem echo --------------------------------------------------

 set timedayly=!time: =0!
 set timedayly=!timedayly:~0,-6!
 for /l %%i in (1,1,!dayly.0!) do if !dayly.%%i!==!timedayly! (
     if not exist %flagsdir%\%doneflag%.%%i.!DATE! (
        del /f/q %flagsdir%\%doneflag%.%%i.* 2>nul
        echo.>%flagsdir%\%doneflag%.%%i.!DATE!
        Echo Dayly Event !dayly.%%i.desc!
        Call :dolog "!dayly.%%i.desc!, Exec !dayly.%%i.cmd!"
        cmd /c "!dayly.%%i.cmd!"
        Call :dolog "!dayly.%%i.desc!, End."
     ) else echo       !dayly.%%i!: "!dayly.%%i.desc!"
     ) else echo       !dayly.%%i!: "!dayly.%%i.desc!"
rem echo --------------------------------------------------
 set curday=%date:~0,-8%
 set ddtttt=!curday: =0!.!timedayly!
 for /l %%i in (1,1,!monthly.0!) do if !ddtttt!==!monthly.%%i! (
     if not exist %flagsdir%\%doneflag%.month.%%i.!DATE! (
        del /f/q %flagsdir%\%doneflag%.month.%%i.* 2>nul
        echo.>%flagsdir%\%doneflag%.month.%%i.!DATE!
        Echo Monthly Event !monthly.%%i.desc!
        Call :dolog "Monthly Event: !monthly.%%i.desc!, !monthly.%%i.cmd!"
        cmd /c !monthly.%%i.cmd!
        Call :dolog "Monthly Event: !monthly.%%i.desc!, End."
     ) else echo    !monthly.%%i!: "!monthly.%%i.desc!"
     ) else echo    !monthly.%%i!: "!monthly.%%i.desc!"
rem echo --------------------------------------------------
 set curb=!date:~0,-5!.!timedayly!
 for /l %%i in (1,1,!birthday.0!) do if !curb!==!birthday.%%i! (
     if not exist %flagsdir%\%doneflag%.birthday.%%i.!DATE! (
        del /f/q %flagsdir%\%doneflag%.birthday.%%i.* 2>nul
        echo.>%flagsdir%\%doneflag%.birthday.%%i.!DATE!
        Echo Birthday Event "!birthday.%%i.desc!"
        Call :dolog "Birthday Event: !birthday.%%i.desc!, !birthday.%%i.cmd!"
        cmd /c !birthday.%%i.cmd!
        Call :dolog "Birthday Event: !birthday.%%i.desc! End."
     ) else echo !birthday.%%i!: "!birthday.%%i.desc!"
     ) else echo !birthday.%%i!: "!birthday.%%i.desc!"

rem ---   ------------------------------------------------------

  if exist %flagsdir%\poll.now (
     Call :DoLog "Flag  poll.now found..."
     echo Flag  poll.now found...
     for /f  "eol=; tokens=1,2,3,4* delims=:/. " %%i in (%flagsdir%\poll.now) do echo   Node %%i:%%j/%%k.%%l found.&Call :DoLog "  Node %%i:%%j/%%k.%%l found."&Call :DoPoll %%i %%j %%k %%l
     del /f/q %flagsdir%\poll.now
     if exist %flagsdir%\poll.now (
        call :dolog "Can not delete %flagsdir%\poll.now"
        echo Can not delete %flagsdir%\poll.now
     )
  )

  for /l %%i in (1,1,!Flag.0!) do if exist %flagsdir%\!flag.%%i! (
       Call :dolog "Flag !flag.%%i! found. Exec !flag.%%i.cmd!."
       Echo Flag !flag.%%i! found. Exec !flag.%%i.cmd!.
       cmd /c !flag.%%i.cmd!
       Echo Flag !flag.%%i! found. End.
       del /f/q %flagsdir%\!flag.%%i!
      )

  if exist %flagsdir%\%exitflag% goto End

rem ---- ஢塞  﫨  䠩,  ࠢ -----------------

Call :TestSeg

rem --- ஢塞  﫨   䨣 ------------------------------------

 for %%i in (%~dpn0.*) do if not !filestamp%%~xi! == %%~tzi (
     echo %%~nxi changed.
     Call :dolog "%%~nxi changed."
     if /i %%~xi == .cmd (
        echo start /i /min %%~dpirestart.cmd %%~fi %flagsdir%\%lockfile%
	Call :dolog "Restart."
        start /i /min %%~dpirestart.cmd %%~fi
        goto End
     ) else (
       if  /i %%~xi == .cfg (
          Call :ReadCFG
	  Call :dolog "%%~nxi reread."
       ) else ( 
         if /i %%~xi == .poll (
            Call :ReadPollNodes
	    Call :dolog "%%~nxi reread."
         ) else ( 
           if /i %%~xi == .event (
              Call :ReadEvent
	      Call :dolog "%%~nxi reread."
           )
         )
       )  
     )
     set filestamp%%~xi=%%~tzi
     )
  rem else (     echo.     )

rem --------------------------------------------------------------------------

rem for /l %%i in (1,1,!addsrings!) do echo.

rem	Call :KeepRunning

timeout /NOBREAK /T %TT% >nul
 for /l %%i in (1,1,%node2poll%) do set /a polltriger%%i=!polltriger%%i!-%TT%

goto StartCircle

:End
 if exist %flagsdir%\%exitflag% del /f/q %flagsdir%\%exitflag%
 if exist %flagsdir%\%lockfile% del /f/q %flagsdir%\%lockfile%
 call :dolog "Normal exit."
 exit


rem --------------------------------------------------------------------------

:ReadPollNodes

     set /a nn=0
     if exist %pollnodes% (
     FOR /F "eol=; tokens=1,2,3,4,5* delims=:/. " %%i in (%pollnodes%) do set /a nn=!nn!+1&set /a node2poll.!nn!.zone=%%i&set /a node2poll.!nn!.net=%%j&set /a node2poll.!nn!.node=%%k&set /a node2poll.!nn!.point=%%l&set node2poll.!nn!.period=%%m&set polltriger!nn!=%%m
     )
     set /a node2poll=!nn!
rem     echo We have !node2poll! nodees to poll.
rem     set /a addsrings = !addsrings!-%node2poll%

exit /b


:ReadCFG

   Call :setvar
   Echo readin config...
   set /a f=0
   set /a Flag.0=0
   rem                  i j k l m
   FOR /F "eol=; tokens=1,2,3,4* delims=, " %%i in (%cfgfile%) do if /i %%i == flagsdir (
       set FlagsDIR=%%j
       if not exist !FlagsDIR! md !FlagsDIR!
       ) else if /i %%i == outbound (
       set outbound=%%j
       if not exist !outbound! md !outbound!
       ) else if /i %%i == logdir (
       set logdir=%%j
       if not exist !logdir! md !logdir!
       ) else if /i %%i == delay (
       set /a TT=%%j
       ) else if /i %%i == DefaultZone (
       set /a DefaultZone=%%j
       ) else if /i %%i == Flag (
       set /a f+=1 
       set /a Flag.0=!f!
       set Flag.!f!=%%j
       set Flag.!f!.cmd=%%k %%l %%m
       )else if /i %%i == inbound (
       set inbound=%%j
       if not exist !inbound! md !inbound!
       ) else if /i %%i == brakeboxes (
       set brakeboxes=%%j
       if not exist !brakeboxes! md !brakeboxes!
       ) else if /i %%i == segname (
       set /a s+=1 
       set /a seg.0=!s!
       set seg.!s!=%%j
       set seg.!s!.path=%%k
       set seg.!s!.flavor=%%l
       set seg.!s!.address=%%m
       ) else if /i %%i == ShowIfTriggerLess (
       set /a ShowIfTriggerLess=%%j
       ) else if /i %%i == KeepRunning (
       set /a r+=1 
       set /a KeepRunning.0=!r!
       set KeepRunning.!r!=%%j
       set KeepRunning.!r!.exec=%%k %%l %%m
       )

   Echo Done.

exit /b

:setvar
 set h.0=0
 set h.1=1
 set h.2=2
 set h.3=3
 set h.4=4
 set h.5=5
 set h.6=6
 set h.7=7
 set h.8=8
 set h.9=9
 set h.10=a
 set h.11=b
 set h.12=c
 set h.13=d
 set h.14=e
 set h.15=f

 set d.0=0
 set d.1=1
 set d.2=2
 set d.3=3
 set d.4=4
 set d.5=5
 set d.6=6
 set d.7=7
 set d.8=8
 set d.9=9
 set d.a=10
 set d.b=11
 set d.c=12
 set d.d=13
 set d.e=14
 set d.f=15
exit /b


:DoLog
  set day_time=!DATE! !TIME: =0!
  echo !day_time:~0,-3! * %~1>>%logdir%\%logfile%
exit /b

:dec2hex
 set /a dec=%~1
 set /a x=dec/16
 rem    
 set /a z=dec-(x*16)
 set b=!h.%z%!
 set hex=!b!!hex!
 if not !x! == 0 call :dec2hex !x!
 set hex=0000!hex!
exit /b

:DoPoll
  set _out=%outbound%
  if /i %~1 NEQ !DefaultZone! (
     set _ext=000
     set _ext=!_ext!%~1
     set _out=!outbound!.!_ext:~-3!
     if not exist !_out! md !_out!
  )
  set hex=& call :dec2hex %~2& set _lo=!hex:~-4!
  set hex=& call :dec2hex %~3& set _lo=!_lo!!hex:~-4!
  if not %~4==0 (
     if not exist %_out%\!_lo!.pnt md %_out%\!_lo!.pnt
     set hex=& call :dec2hex %~4& set _lo=!_lo!.pnt\0000!hex:~-4!
  )
  set _lo=!_lo!.ilo
  if not exist %_out%\!_lo! (
     echo 1>nul 2>%_out%\!_lo!
     echo Poll to %~1:%~2/%~3.%~4 !_lo! generated.
     Call :DoLog "Poll to %~1:%~2/%~3.%~4 !_lo! generated."
  ) else (
     echo Poll to %~1:%~2/%~3.%~4 !_lo! exist.
     Call :DoLog "Poll to %~1:%~2/%~3.%~4 !_lo! exist."
  )
exit /b


:SetFlo

  set _out=%outbound%
  if /i %~1 NEQ !DefaultZone! (
     set _ext=000
     set _ext=!_ext!%~1
     set _out=!outbound!.!_ext:~-3!
     if not exist !_out! md !_out!
  )
  set hex=& call :dec2hex %~2& set _lo=!hex:~-4!
  set hex=& call :dec2hex %~3& set _lo=!_lo!!hex:~-4!
  if not %~4==0 (
     if not exist %_out%\!_lo!.pnt md %_out%\!_lo!.pnt
     set hex=& call :dec2hex %~4& set _lo=!_lo!.pnt\0000!hex:~-4!
  )
  set _flo=!_out!\!_lo!

exit /b


:ReadEvent
   Echo readin events...
   set /a ed=0
   set /a ep=0
   set /a em=0
   set /a eb=0
   set /a hh=0
   FOR /F "eol=; tokens=1,2,3* delims=, " %%i in (%eventfile%) do if /i %%i==dayly (
       set /a ed = !ed!+1
       set dayly.!ed!=%%j
       set dayly.!ed!.desc=%%k
       set dayly.!ed!.cmd=%%l
       ) else if /i %%i==period (
       set /a ep=!ep!+1
       set /a period.!ep!=%%j
       set /a period.!ep!.trigger=%%j
       set period.!ep!.desc=%%k
       set period.!ep!.cmd=%%l
       ) else if /i %%i==monthly (
       set /a em=!em!+1
       set monthly.!em!=%%j
       set monthly.!em!.desc=%%k
       set monthly.!em!.cmd=%%l
       ) else if /i %%i==birthday (
       set /a eb=!eb!+1
       set birthday.!eb!=%%j
       set birthday.!eb!.desc=%%k
       set birthday.!eb!.cmd=%%l
       ) else if /i %%i == Hold (
       set /a hh+=1
       set hold.!hh!.address=%%j
       set hold.!hh!.StartTime=%%k
       set hold.!hh!.EndTime=%%l
       set hold.!hh!.Done=0
       set /a hold.0=!hh!
       )

   set /a dayly.0=!ed!
   set /a period.0=!ep!
   set /a monthly.0=!em!
   set /a birthday.0=!eb!
exit /b

:TestSeg
 set /a s=0
 :Seg_Start
  if !seg.0!==!s! goto Seg_End
  set /a s+=1
rem  Echo Testing File !seg.%s%! to send (Flavor !seg.%s%.flavor!, Address !seg.%s%.address!).
  if not exist !seg.%s%.path!\!seg.%s%! (
     Echo File !seg.%s%.path!\!seg.%s%! not found.
     Call :dolog "File !seg.%s%.path!\!seg.%s%! not found."
     goto Seg_Start
  )
  for %%i in (!seg.%s%.path!\!seg.%s%!) do set curstamp=%%~tzi
  if not exist %flagsdir%\!seg.%s%!.stamp (
     echo %curstamp%>%flagsdir%\!seg.%s%!.stamp
     echo Filestamp "%curstamp%" is set.
     Call :dolog "Filestamp of !seg.%s%! is set as %curstamp%."
  ) else (
    for /f "eol=; tokens=* delims= " %%i in (%flagsdir%\!seg.%s%!.stamp) do set oldstamp=%%i
    if not "!curstamp!"=="!oldstamp!" (
      echo * File !seg.%s%! changed. Sending !seg.%s%.flavor! to !seg.%s%.address!.
      Call :dolog "File !seg.%s%! changed. Sending !seg.%s%.flavor! to !seg.%s%.address!."
      set _addr=!seg.%s%.address!&&set _addr=!_addr::= !&set _addr=!_addr:/= !&set _addr=!_addr:.= !
      set _flv=!seg.%s%.flavor!&set _flv=!_flv:~0,1!
      Call :SetFlo !_addr!
      if not exist !_flo!.bsy (
         echo.>!_flo!.bsy
         echo !seg.%s%.path!\!seg.%s%!>>!_flo!.!_flv!lo
         echo File !seg.%s%! sent to !seg.%s%.address!.
         Call :DoLog "File !seg.%s%! sent to !seg.%s%.address!."
         Call :DoLog "     !_flo!.!_flv!lo."
         del /f/q !_flo!.bsy
         echo %curstamp%>%flagsdir%\!seg.%s%!.stamp
      ) else ( echo Address !seg.%s%.address! is busy.
               Call :DoLog "Address !seg.%s%.address! is busy."
             )
    )
  )

  
  goto Seg_Start
 :Seg_End
rem  echo !seg.0! !s!
exit /b


:Addr2String
  set _address=%~1
  set _address=!_address::= !
  set _address=!_address:/= !
  set _address=!_address:.= !
exit /b


:hex2dec
 set _hex=%~1
 set /a _dec=0
 set /a _m=1
 set /a _i=3
 :Sh2d
   set _h=!_hex:~%_i%,1!
   set /a x=!d.%_h%!
   set /a _dec+=!x!*!_m!
   if !_i!==0 goto Eh2d
   set /a _i-=1
   set /a _m*=16
   goto Sh2d
 :Eh2d
exit /b

:TestHld

   set /a hh=0
   :StartHld

   if !hh!==!hold.0! goto EndHld
   set /a hh+=1
   set _addrstr=                !hold.%hh%.address!
   set curTimeH=%TIME:~0,-6%
   echo !hold.%hh%.StartTime!-!hold.%hh%.EndTime!  Hold !hold.%hh%.address!
   if not !hold.%hh%.StartTime!==%curTimeH: =0% goto StartHld

   Call :Addr2String !hold.%hh%.address!
   Call :SetFlo !_address!

   if exist !_flo!.hld (
	for %%I in ( !_flo!.hld ) do if "%%~tI" == "!date:/=.! !curTimeH: =0!" goto StartHld
   )

   Call :CalcHoldTime
   echo !Hsec!>!_flo!.hld
   Call :DoLog "Holding !hold.%hh%.address! from: !hold.%hh%.StartTime! to: !hold.%hh%.EndTime! !_flo!.hld"
rem pause
rem   echo HoldTime> !_flo!.hld

   set hold.!hh!.Done=1
   goto StartHld
     
:EndHld

exit /b


:FName2AddrNode
 set _filename=%~1
 Call :hex2dec !_filename:~0,4!
 set _netA=!_dec!
 Call :hex2dec !_filename:~-4!
 set _nodeA=!_dec!
exit /b


:CalcHoldTime

  Call :Time2Seconds !Hold.%hh%.StartTime::= !
  set /a Ssec=!Seconds!
  Call :Time2Seconds !Hold.%hh%.EndTime::= !
  set /a Esec= !Seconds!

  if !Ssec! gtr !Esec! (
     set /a HoldSeconds=86400-!Ssec!+!Esec!
  ) else (
     set /a HoldSeconds=!Esec!-!Ssec!
  )
  set tmpFile=%tmp%\%DATE%.%TIME:~-2%.%RANDOM%
  D:\Programs\UnixUtils\date.exe +%%s>!tmpFile!
  set /p Hsec=<!tmpFile!
  set /a Hsec+=!HoldSeconds!
  del /f/q !tmpFile!
 
exit /b

:Time2Seconds
  set _x=%~1
  if %_x:~0,1%==0 set /a _x=!_x:1,1!
  set /a _x*=3600
  set _y=%~2
  if %_y:~0,1%==0 set /a _y=!_y:1,1!
  set /a _y*=60
  set /a Seconds=!_x!+!_y!
exit /b


:KeepRunning
  set /a r=!KeepRunning.0!
  :KR
	tasklist /v /fo table | find /i "!KeepRunning.%r%!">nul
	if not %errorlevel% == 0 cmd /c !KeepRunning.%r%.exec!
	set /a r += 1
	if !r! leq !KeepRunning.0! goto KR
exit /b


